<template>
    <div>
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div class="mt-1 relative">
            <textarea
                :id="id"
                :name="name"
                :placeholder="placeholder"
                :value="data"
                :disabled="disabled"
                :readonly="readonly"
                class="form-control"
                :rows="rows"
                :class="{
                    'pl-7': prependIcon,
                    'pr-12': appendIcon,
                    'border-gray-300': !errors,
                    'border-red-500': errors && errors.length,
                    'text-red-500': errors && errors.length,
                    'opacity-50': disabled || readonly,
                    'hide-arrow': number,
                    'disabled': disabled || readonly,
                }"
                @input="data = $event.target.value"
                @keypress="checkForRestriction"
            />
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {ref, watch} from 'vue';
const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    rows: {
        required: false,
        type: [String, Number],
        default: 4,
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    prependIcon: {
        required: false,
        type: String,
        default: null,
    },
    appendIcon: {
        required: false,
        type: String,
        default: null,
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    },
    fund: {
        required: false,
        type: Boolean,
        default: false,
    },
    number: {
        required: false,
        type: Boolean,
        default: false,
    }
});
let data = ref(props.modelValue);
const emit = defineEmits(['update:modelValue']);

watch(data, (newValue) => {
    emit('update:modelValue', newValue);
});

const checkForRestriction = (event) => {
    if (props.fund) {
        // console.log($event.keyCode); //keyCodes value
        let keyCode = (event.keyCode ? event.keyCode : event.which);

        // only allow number and one dot
        if ((keyCode < 48 || keyCode > 57) && (keyCode !== 46 || data.value.indexOf('.') !== -1)) { // 46 is dot
            event.preventDefault();
        }

        // restrict to 2 decimal places
        if(data.value != null && data.value.indexOf(".") > -1 && (data.value.split('.')[1].length > 1)) {
            event.preventDefault();
        }
    } else if (props.number) {
        let keyCode = (event.keyCode ? event.keyCode : event.which);

        // only allow number
        if (keyCode < 48 || keyCode > 57) {
            event.preventDefault();
        }
    }
};
</script>
